;--------------------------------------------------------------------------------------------------------------------------------------------------------------
.model tiny
.stack 64
.code
org 100h


;--------------------------------------------------------------------------------------------------------------------------------------------------------------
.startup

;Parse command-line options
mov al, byte ptr ds:[80h]
;We have arguments
.if al > 0
	call ShowHelp
.else
	call DoIt
.endif
.exit



;--------------------------------------------------------------------------------------------------------------------------------------------------------------
;Enable/Disable in AL
DoIt proc
	;Check if stdout is redirected
    mov ax,4400h
    mov bx, 1	;1=Standard output device (Stdout)
    int 21h
	mov ax, dx
    and ax, 80h
	.if (ax != 0)
		;Set videomode to current mode
		mov ah, 0fh
		int 10h
		xor ah, ah
		int 10h
	.else
		;Use ANSI sequence
		mov dx, offset acAnsiCls
		call PrintText
	.endif
	ret
DoIt endp

;--------------------------------------------------------------------------------------------------------------------------------------------------------------
ShowHelp proc
	mov dx, offset acCopyright
	call PrintText
	
	mov dx, offset acCrLf
	call PrintText
	
	;Return
	mov al, -1
	ret
ShowHelp endp


	
;--------------------------------------------------------------------------------------------------------------------------------------------------------------
;Text in DX
PrintText proc uses ax
	mov ah, 9
	int 21h
	ret
PrintText endp

;--------------------------------------------------------------------------------------------------------------------------------------------------------------
.data
acCopyright		db 13, 10
				db "CLS R1.00                          (c) 2022 by Javier Gutierrez Chamorro (Guti)", 13, 10
				db "Clears the screen.", 13, 10, 10
acHelp			db "Syntax is: CLS [-h]", 13, 10, 10
				db "Examples:", 13, 10, 10
				db "	CLS -h", 13, 10
				db "	Shows this help screen.", 13, 10
				db "	CLS", 13, 10
				db "	Clear screen in current video mode.", 13, 10, 10
				db "More information at:", 13, 10
				db "	http://nikkhokkho.sourceforge.net/static.php?page=CLS", 13, 10
acCrLf			db 13, 10, '$'
acAnsiCls		db "[2J$"
end